Package ru.bitel.bgbilling.modules.voice.server.bean.operator

# Class Operator

java.lang.Object
ru.bitel.bgbilling.kernel.base.server.logger.BGLogger
ru.bitel.bgbilling.modules.voice.server.bean.operator.Operator

Direct Known Subclasses:
  `Infolada`, `Sovintel`

public abstract class Operator extends ru.bitel.bgbilling.kernel.base.server.logger.BGLogger
Общий класс для каждого оператора (в каждом может быть несколько отчётов).

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final String`
  `ABONENT_SNAPSHOT_TABLE_PREFIX`
  `protected Map<Integer,Integer>`
  `billingToOperServiceMap`
  `protected int`
  `id`
  `protected String`
  `incorrectOperatorMessage`
  `protected int`
  `mid`
  `protected Preferences`
  `moduleSetup`
  `protected Preferences`
  `operatorSetup`
  `protected Map<Integer,Integer>`
  `operToBillingServiceMap`
  `protected List<Integer>`
  `serviceList`
  `protected List<Integer>`
  `tariffList`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Operator()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract void`
  `checkCorrectOperator()`
  Оператор должен проверить свои настройки и если что-то не так - кинуть экзепшен.
  `protected void`
  `clearSnapshot(Connection con, Date month)`
  `abstract void`
  `createAbonentSnapshot(Connection con, Date month)`
  `Map<Integer,Integer>`
  `getBillingToOperServiceMap()`
  `Set<Integer>`
  `getChangedAbonents(Connection con, Date toMonth)`
  `int`
  `getContractId()`
  `int`
  `getId()`
  `protected PreparedStatement`
  `getInsertSnapshotPs(Connection con, Date month)`
  `Date`
  `getLastPrevSnapshot(Connection con, Date month)`
  `int`
  `getModuleId()`
  `Preferences`
  `getModuleSetup()`
  `Preferences`
  `getOperatorSetup()`
  `Map<Integer,Integer>`
  `getOperToBillingServiceMap()`
  `Report`
  `getReport(int id, Date month)`
  `List<Report>`
  `getReportList(Date month)`
  `abstract List<Report>`
  `getReportList(Date month, boolean hasSnapshot)`
  `List<Integer>`
  `getServiceList()`
  `List<Integer>`
  `getTariffList()`
  `String`
  `getTitle()`
  `boolean`
  `hasShapshot(Connection con, Date month)`
  `void`
  `init(int id, int cid, String title, int mid, Preferences moduleSetup, Preferences operatorSetup)`
  `abstract boolean`
  `needAbonentSnapshot()`

  ### Methods inherited from class ru.bitel.bgbilling.kernel.base.server.logger.BGLogger

  `error, error, error, getLogger, logError, logError, warn`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### id

    protected int id

  - ### mid

    protected int mid

  - ### moduleSetup

    protected Preferences moduleSetup

  - ### operatorSetup

    protected Preferences operatorSetup

  - ### serviceList

    protected List<Integer> serviceList

  - ### tariffList

    protected List<Integer> tariffList

  - ### billingToOperServiceMap

    protected Map<Integer,Integer> billingToOperServiceMap

  - ### operToBillingServiceMap

    protected Map<Integer,Integer> operToBillingServiceMap

  - ### ABONENT_SNAPSHOT_TABLE_PREFIX

    protected static final String ABONENT_SNAPSHOT_TABLE_PREFIX
    See Also:
      - Constant Field Values

  - ### incorrectOperatorMessage

    protected String incorrectOperatorMessage

- ## Constructor Details

  - ### Operator

    public Operator()

- ## Method Details

  - ### init

    public void init(int id, int cid, String title, int mid, Preferences moduleSetup, Preferences operatorSetup)

  - ### getId

    public int getId()

  - ### getTitle

    public String getTitle()

  - ### getModuleId

    public int getModuleId()

  - ### getContractId

    public int getContractId()

  - ### getServiceList

    public List<Integer> getServiceList()

  - ### getBillingToOperServiceMap

    public Map<Integer,Integer> getBillingToOperServiceMap()

  - ### getOperatorSetup

    public Preferences getOperatorSetup()

  - ### getOperToBillingServiceMap

    public Map<Integer,Integer> getOperToBillingServiceMap()

  - ### getModuleSetup

    public Preferences getModuleSetup()

  - ### hasShapshot

    public boolean hasShapshot(Connection con, Date month)

  - ### getLastPrevSnapshot

    public Date getLastPrevSnapshot(Connection con, Date month)

  - ### getInsertSnapshotPs

    protected PreparedStatement getInsertSnapshotPs(Connection con, Date month) throws SQLException
    Throws:
      `SQLException`

  - ### clearSnapshot

    protected void clearSnapshot(Connection con, Date month) throws SQLException
    Throws:
      `SQLException`

  - ### getChangedAbonents

    public Set<Integer> getChangedAbonents(Connection con, Date toMonth)

  - ### getReport

    public Report getReport(int id, Date month)

  - ### needAbonentSnapshot

    public abstract boolean needAbonentSnapshot()

  - ### createAbonentSnapshot

    public abstract void createAbonentSnapshot(Connection con, Date month)

  - ### getReportList

    public List<Report> getReportList(Date month)

  - ### getReportList

    public abstract List<Report> getReportList(Date month, boolean hasSnapshot)

  - ### getTariffList

    public List<Integer> getTariffList()

  - ### checkCorrectOperator

    public abstract void checkCorrectOperator() throws ru.bitel.bgbilling.common.BGException
    Оператор должен проверить свои настройки и если что-то не так - кинуть экзепшен.
    Throws:
      `ru.bitel.bgbilling.common.BGException` - экзепшен с сообщением.